#  Copyright (c) 2025. Affects AI LLC
#
#  Licensed under the Creative Common CC BY-NC-SA 4.0 International License (the "License");
#  you may not use this file except in compliance with the License. The full text of the License is
#  provided in the included LICENSE file. If this file is not available, you may obtain a copy of the
#  License at
#
#       https://creativecommons.org/licenses/by-nc-sa/4.0/deed.en
#
#  Unless required by applicable law or agreed to in writing, software distributed under the License
#  is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
#  express or implied. See the License for the specific language governing permissions and limitations
#  under the License.
import abc


class AERTrialFilter:
    def __init__(self, trial_filter_function, **fn_kwargs):
        self.trial_filter_function = trial_filter_function
        self.fn_kwargs = fn_kwargs

    @abc.abstractmethod
    def filter(self, trial) -> bool:
        return self.trial_filter_function(trial, **self.fn_kwargs)